/* Simple example: server */
/* Per gestire la comunicazione in rete */
#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <netinet/in.h>
/* Per usare la printf */
#include <stdio.h>
/* Per usare la exit */
#include <stdlib.h>
/* Per usare la read e la write */
#include <unistd.h>




int InviaTextFile(const char *NomeFile, int TxSocket)
{
	char Lettore;
	int ret;
	FILE	*Source=fopen(NomeFile,"r");
	for(Lettore=(char)fgetc(Source);Lettore!=EOF;Lettore=(char)fgetc(Source))
	{
		ret=write(TxSocket,&Lettore,1);
		if(ret<0)
		{
			fclose(Source);
			return -1;
		}
	}
        fclose(Source);
	return 0;
}


int Esegui(const char *Comando, const char *NomeFile)
{
	char RealCMD[257];
	if(strlen(Comando)+strlen(NomeFile) > 250)return -1;
	strcpy(RealCMD,"ls ");
	strcat(RealCMD,Comando);
	strcat(RealCMD," > ");
	strcat(RealCMD,NomeFile);
	system(RealCMD);
	return 0;
}
 
int
main(int argc, char *argv[])
{
  struct sockaddr_in cl_addr, serv_addr;
  int len;
  int sd, sd1;
  int ret;
  int Dst;

  char TMPCLIENT[20];
  char TMPCMD[250];

  pid_t	SLAVE;

  char buf[4096]; 
  char Lettore;
  FILE *HTML=NULL;

  int Port=7890;


	/* Setting up global Vbr */
  	/* Line command 	*/
 	if(argc > 2)
  {
	  if(sscanf(argv[1],"%d",&Port)!=1)
	  {
		  fprintf(stderr,"Error: You can only specify the port");
	  }
  }
  
  serv_addr.sin_family= AF_INET;
  serv_addr.sin_port= htons(Port);
  serv_addr.sin_addr.s_addr= INADDR_ANY;

	sd = socket( AF_INET, SOCK_STREAM,0);
	if(sd<0) fprintf(stderr,"Error: socket()");

	printf("\nSERVER: Setting up...\n");

	ret= bind(sd, (struct sockaddr*)&serv_addr,sizeof(serv_addr));
	printf("started service at %d\n",Port);

	ret=listen(sd, 5);
	if(ret<0) fprintf(stderr,"Error: listen()");


	for(;;)
	{

	len = sizeof(cl_addr);

	sd1 =accept(sd, (struct sockaddr*)&cl_addr, &len);
	if(ret<0) fprintf(stderr,"Error: accept()");
	printf("CLIENT: %lX[%d], waiting for authentication...\n",
			cl_addr.sin_addr.s_addr,
		  	cl_addr.sin_port);
  
		ret = read(sd1, buf, 1024);

		if(ret<0)break;
				
			/* checcking for HTML or text */
		
		SLAVE=fork();

		if(SLAVE==0){
			printf("figlio\n");
			sprintf(TMPCLIENT,"TMP%lx%d",
			                        cl_addr.sin_addr.s_addr,
			                       cl_addr.sin_port);
			if(strncmp(buf,"GET",3)==0)
			{
				printf("HTML\n",buf);
				if(strncmp(buf,"GET / HTTP",10)==0)
				{
					if(InviaTextFile("client.html",sd1));
					printf("The Index was sent.\n");
				}
				if(strncmp(buf,"GET /-l HTTP",12)==0)
				{
					if(InviaTextFile("start.html",sd1));
					
					Esegui("-l",TMPCLIENT);
					
					printf("ls -l\n");
					if(InviaTextFile(TMPCLIENT,sd1));
					if(InviaTextFile("stop.html",sd1));
				}
				if(strncmp(buf,"GET /cmd:",9)==0)
				{
					if(InviaTextFile("start.html",sd1));
					for(Dst=0;buf[Dst+9]!=' ';Dst++)
					{
						TMPCMD[Dst]=buf[Dst+9];
					}
					TMPCMD[Dst]=0;
					TMPCMD[Dst+1]=0;
					
					Esegui(TMPCMD,TMPCLIENT);
					printf("command: %s\n",TMPCMD);
					if(InviaTextFile(TMPCLIENT,sd1));
					if(InviaTextFile("stop.html",sd1));
				}
				sprintf(TMPCMD,"rm %s",TMPCLIENT);
				system(TMPCMD);	
			}
			else
			{
				printf("Plain Text\n");
					/* Text Version */
				if(strncmp(buf,"?",1)==0)
				{
					printf("Help Sent.\n");
					if(InviaTextFile("client.txt",sd1));
				}
				
			}
			close(sd1);
			printf("End.\n");
			exit(0);
		}
		else
		{
			printf("padre\n");
			close(sd1);
		}
	}
	
	close(sd1);
	close(sd);
	printf("\nServer Stopped\n");
	exit(0);
}
